// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "DirectIO.h"
#include "DlgProxy.h"
#include "DirectIODlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDirectIODlgAutoProxy

IMPLEMENT_DYNCREATE(CDirectIODlgAutoProxy, CCmdTarget)

CDirectIODlgAutoProxy::CDirectIODlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CDirectIODlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CDirectIODlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CDirectIODlgAutoProxy::~CDirectIODlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CDirectIODlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CDirectIODlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CDirectIODlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDirectIODlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CDirectIODlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDirectIO to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {7F028E08-7DA6-11D4-81F6-000000000000}
static const IID IID_IDirectIO =
{ 0x7f028e08, 0x7da6, 0x11d4, { 0x81, 0xf6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

BEGIN_INTERFACE_MAP(CDirectIODlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CDirectIODlgAutoProxy, IID_IDirectIO, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {7F028E06-7DA6-11D4-81F6-000000000000}
IMPLEMENT_OLECREATE2(CDirectIODlgAutoProxy, "DirectIO.Application", 0x7f028e06, 0x7da6, 0x11d4, 0x81, 0xf6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0)

/////////////////////////////////////////////////////////////////////////////
// CDirectIODlgAutoProxy message handlers
